class Ball {
  float dx,dy,x,y,r;
  public Ball (float x, float y, float r) {
    this.x = x;
    this.y = y;
    this.r = r;
    dx = random(-5,5);
    dy = random(-5,5);
  }
  
  void move () {
    x += dx;
    y += dy;
    if (x+r>width) {
      x = width-r;
      dx *= -1;
    } else if (x-r<0) {
      x = r;
      dx *= -1;
    }
    if (y+r>height) {
      y = height-r;
      dy *= -1;
    } else if (y-r<0) {
      y = r;
      dy *= -1;
    }
  }
  
  void plot () {
    ellipse(x,y,2*r,2*r);
  }
  
  // a^2 + b^2 = c^2
  // -> c = wurzel(a^2+b^2)
  float calcDistance (Ball other) {
    return sqrt(sq(other.x-x)+sq(other.y-y));
  }
}

Ball b1, b2;

void setup () {
  size(800,800);
  b1 = new Ball (200,200,100);
  b2 = new Ball (200,200,100);
}

void draw () {
  background(0);
  
  // wenn berechnete Distanz kleiner als Summe der Radien
  if (b1.calcDistance(b2)<b1.r+b2.r) {
    fill(255,0,0);
  }
  else {
    fill(255);
  }
  
  b1.move();
  b1.plot();
  
  b2.move();
  b2.plot();
}